#!/bin/sh
#
# Copyright (c) 2009, 2010  Peter Pentchev
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.

# FIXME: usage message

# FIXME: config file

# FIXME: command-line options

display_commands()
{
	while [ "$#" -gt 0 ]; do
		echo "$1"
		shift
	done
}

set -e

if [ -z "$TTY" ]; then
	TTY=`tty`
fi
if [ -z "$TTY" ]; then
	echo "Where are you?" 1>&2
	exit 1
fi

unset cmd1 cmd2 cmd
case "$TTY" in
	/dev/ttyv1)
		set -- 'centerim --ascii'
		;;
	/dev/ttyv2)
		set -- 'cd cvsup' 'teeup c'
		;;
	/dev/tty4)
		set -- 'screen -DR'
		;;
	/dev/tty9)
		set -- 'mutt'
		;;
	/dev/tty10)
		set -- 'mutt -f=unhates'
		;;
	/dev/ttyvd)
		set -- 'startx'
		;;
	/dev/pts/0)
		set -- '-fetchmail -ve200' 'fetchmail -ve25 -Nd120'
		;;
	/dev/pts/1)
		set -- 'mstat -TA'
		set -- 'mstat'
		;;
	/dev/pts/2)
		set -- 'mutt -F .mutt/muttrc-hoster'
		;;
	/dev/pts/3)
		set -- 'mutt -F .mutt/muttrc-cnsys'
		;;
	/dev/pts/4)
		set -- 'sudo vpnc ./vpnc' 'echo up' \
		    'sleep 3' 'ping brionne.int.hoster.bg'
		;;
	/dev/pts/5)
		set -- 'psql -h intdb.int.hoster.bg hoster hoster'
		;;
	*)
		echo "Don't know what to do on tty $TTY!" 1>&2
		exit 1
		;;
esac

echo 'Press Enter to execute'
display_commands "$@"
echo '...or enter anything to skip:'
read foo
if [ -z "$foo" ]; then
	set -e
	[ -n "$clearerr" ] && set +e
	while [ "$#" -gt 0 ]; do
		if [ "$#" = 1 ]; then
			exec $1
		else
			cmd="$1"
			if expr "x$cmd" : 'x-' > /dev/null; then
				cmd=${cmd#-}
				$cmd || true
			else
				$cmd
			fi
		fi
		shift
	done
	echo 'We should not be here after the last exec, should we?!' 1>&2
	exit 1
else
	echo 'Command execution skipped'
fi
